summaryrefslogtreecommitdiffstats
path: root/target/default/target_skeleton/sbin/ifup
diff options
context:
space:
mode:
authormbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-02-06 00:58:10 +0000
committermbm <mbm@3c298f89-4303-0410-b956-a3cf2f4a3e73>2005-02-06 00:58:10 +0000
commit51d47ba15e193e6c95a82784878601e1c1de44f4 (patch)
treec9858d0b30c5bb5ac8dbab9462c5c56849f0331b /target/default/target_skeleton/sbin/ifup
parentc31ac521e420aa0cfd3ddbc0859b29b0e2a3ff3e (diff)
openwrt root
git-svn-id: svn://svn.openwrt.org/openwrt/trunk/openwrt@212 3c298f89-4303-0410-b956-a3cf2f4a3e73
Diffstat (limited to 'target/default/target_skeleton/sbin/ifup')
-rwxr-xr-xtarget/default/target_skeleton/sbin/ifup71
1 files changed, 71 insertions, 0 deletions
diff --git a/target/default/target_skeleton/sbin/ifup b/target/default/target_skeleton/sbin/ifup
new file mode 100755
index 000000000..6b4a7740b
--- /dev/null
+++ b/target/default/target_skeleton/sbin/ifup
@@ -0,0 +1,71 @@
+#!/bin/ash
+. /etc/functions.sh
+ type=$1
+ debug "### ifup $type ###"
+
+ if=$(nvram get ${type}_ifname)
+ if [ "${if%%[0-9]}" = "ppp" ]; then
+ if=$(nvram get pppoe_ifname)
+ fi
+
+ if_valid $if || return
+
+ $DEBUG ifconfig $if down
+ if [ "${if%%[0-9]}" = "br" ]; then
+ stp=$(nvram get ${type}_stp)
+ $DEBUG brctl delbr $if
+ $DEBUG brctl addbr $if
+ $DEBUG brctl setfd $if 0
+ $DEBUG brctl stp $if ${stp:-0}
+ for sif in $(nvram get ${type}_ifnames); do {
+ if_valid $sif || continue
+ $DEBUG ifconfig $sif 0.0.0.0 up
+ $DEBUG brctl addif $if $sif
+ } done
+ fi
+
+ mac=$(nvram get ${type}_hwaddr)
+ ${mac:+$DEBUG ifconfig $if hw ether $mac}
+
+ if_proto=$(nvram get ${type}_proto)
+ case "$if_proto" in
+ static)
+ ip=$(nvram get ${type}_ipaddr)
+ netmask=$(nvram get ${type}_netmask)
+ gateway=$(nvram get ${type}_gateway)
+
+ $DEBUG ifconfig $if $ip ${netmask:+netmask $netmask} broadcast + up
+ ${gateway:+$DEBUG route add default gw $gateway}
+
+ [ -f /etc/resolv.conf ] && return
+
+ debug "# --- creating /etc/resolv.conf ---"
+ for dns in $(nvram get ${type}_dns); do {
+ echo "nameserver $dns" >> /etc/resolv.conf
+ } done
+ ;;
+ dhcp)
+ pidfile=/tmp/dhcp-${type}.pid
+ if [ -f $pidfile ]; then
+ $DEBUG kill $(cat $pidfile)
+ fi
+ ${DEBUG:-eval} "udhcpc -i $if -b -p $pidfile &"
+ ;;
+ pppoe)
+ username=$(nvram get ppp_username)
+ password=$(nvram get ppp_passwd)
+ redial=$(nvram get ppp_redialperiod)
+ idletime=$(nvram get ppp_idletime)
+ mtu=$(nvram get wan_mtu)
+
+ $DEBUG ifconfig $if 0.0.0.0 up
+
+ $DEBUG /sbin/pppoecd $if -u $username -p $password \
+ -i 0 -I $redial -T $idletime -t $mtu -k
+ ;;
+ none)
+ ;;
+ *)
+ echo "### WARNING $if: $if_proto is not supported"
+ ;;
+ esac